org.springframework.beans.factory.support

## Class DefaultListableBeanFactory

- java.lang.Object
- - org.springframework.core.SimpleAliasRegistry
  - - org.springframework.beans.factory.support.DefaultSingletonBeanRegistry
    - - org.springframework.beans.factory.support.FactoryBeanRegistrySupport
      - - org.springframework.beans.factory.support.AbstractBeanFactory
        - - org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory
          - - org.springframework.beans.factory.support.DefaultListableBeanFactory

- All Implemented Interfaces:
    Serializable, BeanFactory, AutowireCapableBeanFactory, ConfigurableBeanFactory, ConfigurableListableBeanFactory, SingletonBeanRegistry, HierarchicalBeanFactory, ListableBeanFactory, BeanDefinitionRegistry, AliasRegistry
  Direct Known Subclasses:
    XmlBeanFactory

      public class DefaultListableBeanFactory
      extends AbstractAutowireCapableBeanFactory
      implements ConfigurableListableBeanFactory, BeanDefinitionRegistry, Serializable

  Default implementation of the `ListableBeanFactory` and `BeanDefinitionRegistry` interfaces: a full-fledged bean factory based on bean definition objects.

  Typical usage is registering all bean definitions first (possibly read from a bean definition file), before accessing beans. Bean definition lookup is therefore an inexpensive operation in a local bean definition table, operating on pre-built bean definition metadata objects.

  Can be used as a standalone bean factory, or as a superclass for custom bean factories. Note that readers for specific bean definition formats are typically implemented separately rather than as bean factory subclasses: see for example `PropertiesBeanDefinitionReader` and `XmlBeanDefinitionReader`.

  For an alternative implementation of the `ListableBeanFactory` interface, have a look at `StaticListableBeanFactory`, which manages existing bean instances rather than creating new ones based on bean definitions.

  Since:
    16 April 2001
  Author:
    Rod Johnson, Juergen Hoeller, Sam Brannen, Costin Leau, Chris Beams, Phillip Webb
  See Also:
    `StaticListableBeanFactory`, `PropertiesBeanDefinitionReader`, `XmlBeanDefinitionReader`, Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.springframework.beans.factory.support.DefaultSingletonBeanRegistry

      `logger, NULL_OBJECT`

    - ### Fields inherited from interface org.springframework.beans.factory.config.AutowireCapableBeanFactory

      `AUTOWIRE_AUTODETECT, AUTOWIRE_BY_NAME, AUTOWIRE_BY_TYPE, AUTOWIRE_CONSTRUCTOR, AUTOWIRE_NO`

    - ### Fields inherited from interface org.springframework.beans.factory.config.ConfigurableBeanFactory

      `SCOPE_PROTOTYPE, SCOPE_SINGLETON`

    - ### Fields inherited from interface org.springframework.beans.factory.BeanFactory

      `FACTORY_BEAN_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultListableBeanFactory()` Create a new DefaultListableBeanFactory.
    `DefaultListableBeanFactory(BeanFactory parentBeanFactory)` Create a new DefaultListableBeanFactory with the given parent.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `allowAliasOverriding()` Only allows alias overriding if bean definition overriding is allowed.
    `boolean` | `containsBeanDefinition(String beanName)` Check if this bean factory contains a bean definition with the given name.
    `void` | `copyConfigurationFrom(ConfigurableBeanFactory otherFactory)` Copy all relevant configuration from the given other factory.
    `void` | `destroySingleton(String beanName)` Destroy the given bean.
    `protected String` | `determinePrimaryCandidate(Map<String,Object> candidateBeans, DependencyDescriptor descriptor)` Determine the primary autowire candidate in the given set of beans.
    `Object` | `doResolveDependency(DependencyDescriptor descriptor, String beanName, Set<String> autowiredBeanNames, TypeConverter typeConverter)`
    `<A extends Annotation> A` | `findAnnotationOnBean(String beanName, Class<A> annotationType)` Find a `Annotation` of `annotationType` on the specified bean, traversing its interfaces and super classes if no annotation can be found on the given class itself, as well as checking its raw bean class if not found on the exposed bean reference (e.g.
    `protected Map<String,Object>` | `findAutowireCandidates(String beanName, Class<?> requiredType, DependencyDescriptor descriptor)` Find bean instances that match the required type.
    `void` | `freezeConfiguration()` Freeze all bean definitions, signalling that the registered bean definitions will not be modified or post-processed any further.
    `AutowireCandidateResolver` | `getAutowireCandidateResolver()` Return the autowire candidate resolver for this BeanFactory (never `null`).
    `<T> T` | `getBean(Class<T> requiredType)` Return the bean instance that uniquely matches the given object type, if any.
    `BeanDefinition` | `getBeanDefinition(String beanName)` Return the bean definition for the given bean name.
    `int` | `getBeanDefinitionCount()` Return the number of beans defined in the factory.
    `String[]` | `getBeanDefinitionNames()` Return the names of all beans defined in this factory.
    `String[]` | `getBeanNamesForAnnotation(Class<? extends Annotation> annotationType)` Find all names of beans whose `Class` has the supplied `Annotation` type, without creating any bean instances yet.
    `String[]` | `getBeanNamesForType(Class<?> type)` Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
    `String[]` | `getBeanNamesForType(Class<?> type, boolean includeNonSingletons, boolean allowEagerInit)` Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
    `<T> Map<String,T>` | `getBeansOfType(Class<T> type)` Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
    `<T> Map<String,T>` | `getBeansOfType(Class<T> type, boolean includeNonSingletons, boolean allowEagerInit)` Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.
    `Map<String,Object>` | `getBeansWithAnnotation(Class<? extends Annotation> annotationType)` Find all beans whose `Class` has the supplied `Annotation` type, returning a Map of bean names with corresponding bean instances.
    `Comparator<Object>` | `getDependencyComparator()` Return the dependency comparator for this BeanFactory (may be `null`.
    `boolean` | `isAutowireCandidate(String beanName, DependencyDescriptor descriptor)` Determine whether the specified bean qualifies as an autowire candidate, to be injected into other beans which declare a dependency of matching type.
    `protected boolean` | `isAutowireCandidate(String beanName, DependencyDescriptor descriptor, AutowireCandidateResolver resolver)` Determine whether the specified bean definition qualifies as an autowire candidate, to be injected into other beans which declare a dependency of matching type.
    `protected boolean` | `isAutowireCandidate(String beanName, RootBeanDefinition mbd, DependencyDescriptor descriptor, AutowireCandidateResolver resolver)` Determine whether the specified bean definition qualifies as an autowire candidate, to be injected into other beans which declare a dependency of matching type.
    `protected boolean` | `isBeanEligibleForMetadataCaching(String beanName)` Considers all beans as eligible for metadata caching if the factory's configuration has been marked as frozen.
    `boolean` | `isConfigurationFrozen()` Return whether this factory's bean definitions are frozen, i.e.
    `protected boolean` | `isPrimary(String beanName, Object beanInstance)` Return whether the bean definition for the given bean name has been marked as a primary bean.
    `protected boolean` | `matchesBeanName(String beanName, String candidateName)` Determine whether the given candidate name matches the bean name or the aliases stored in this bean definition.
    `void` | `preInstantiateSingletons()` Ensure that all non-lazy-init singletons are instantiated, also considering `FactoryBeans`.
    `void` | `registerBeanDefinition(String beanName, BeanDefinition beanDefinition)` Register a new bean definition with this registry.
    `void` | `registerResolvableDependency(Class<?> dependencyType, Object autowiredValue)` Register a special dependency type with corresponding autowired value.
    `void` | `registerSingleton(String beanName, Object singletonObject)` Register the given existing object as singleton in the bean registry, under the given bean name.
    `void` | `removeBeanDefinition(String beanName)` Remove the BeanDefinition for the given name.
    `protected void` | `resetBeanDefinition(String beanName)` Reset all bean definition caches for the given bean, including the caches of beans that are derived from it.
    `Object` | `resolveDependency(DependencyDescriptor descriptor, String beanName, Set<String> autowiredBeanNames, TypeConverter typeConverter)` Resolve the specified dependency against the beans defined in this factory.
    `void` | `setAllowBeanDefinitionOverriding(boolean allowBeanDefinitionOverriding)` Set whether it should be allowed to override bean definitions by registering a different definition with the same name, automatically replacing the former.
    `void` | `setAllowEagerClassLoading(boolean allowEagerClassLoading)` Set whether the factory is allowed to eagerly load bean classes even for bean definitions that are marked as "lazy-init".
    `void` | `setAutowireCandidateResolver(AutowireCandidateResolver autowireCandidateResolver)` Set a custom autowire candidate resolver for this BeanFactory to use when deciding whether a bean definition should be considered as a candidate for autowiring.
    `void` | `setDependencyComparator(Comparator<Object> dependencyComparator)` Set a `Comparator` for dependency Lists and arrays.
    `void` | `setSerializationId(String serializationId)` Specify an id for serialization purposes, allowing this BeanFactory to be deserialized from this id back into the BeanFactory object, if needed.
    `String` | `toString()`
    `protected Object` | `writeReplace()`

    - ### Methods inherited from class org.springframework.beans.factory.support.AbstractAutowireCapableBeanFactory

      `applyBeanPostProcessorsAfterInitialization, applyBeanPostProcessorsBeforeInitialization, applyBeanPostProcessorsBeforeInstantiation, applyBeanPropertyValues, applyMergedBeanDefinitionPostProcessors, applyPropertyValues, autowire, autowireBean, autowireBeanProperties, autowireByName, autowireByType, autowireConstructor, checkDependencies, configureBean, createBean, createBean, createBean, createBeanInstance, destroyBean, determineConstructorsFromBeanPostProcessors, doCreateBean, filterPropertyDescriptorsForDependencyCheck, filterPropertyDescriptorsForDependencyCheck, getEarlyBeanReference, getInstantiationStrategy, getParameterNameDiscoverer, getTypeForFactoryBean, getTypeForFactoryMethod, ignoreDependencyInterface, ignoreDependencyType, initializeBean, initializeBean, instantiateBean, instantiateUsingFactoryMethod, invokeCustomInitMethod, invokeInitMethods, isExcludedFromDependencyCheck, populateBean, postProcessObjectFromFactoryBean, predictBeanType, removeSingleton, resolveBeforeInstantiation, resolveDependency, setAllowCircularReferences, setAllowRawInjectionDespiteWrapping, setInstantiationStrategy, setParameterNameDiscoverer, unsatisfiedNonSimpleProperties`

    - ### Methods inherited from class org.springframework.beans.factory.support.AbstractBeanFactory

      `addBeanPostProcessor, addEmbeddedValueResolver, addPropertyEditorRegistrar, afterPrototypeCreation, beforePrototypeCreation, checkMergedBeanDefinition, cleanupAfterBeanCreationFailure, clearMergedBeanDefinition, containsBean, containsLocalBean, copyRegisteredEditorsTo, destroyBean, destroyBean, destroyScopedBean, doGetBean, evaluateBeanDefinitionString, getAccessControlContext, getAliases, getBean, getBean, getBean, getBean, getBeanClassLoader, getBeanExpressionResolver, getBeanPostProcessorCount, getBeanPostProcessors, getConversionService, getCustomEditors, getCustomTypeConverter, getMergedBeanDefinition, getMergedBeanDefinition, getMergedBeanDefinition, getMergedLocalBeanDefinition, getObjectForBeanInstance, getParentBeanFactory, getPropertyEditorRegistrars, getRegisteredScope, getRegisteredScopeNames, getTempClassLoader, getType, getTypeConverter, hasDestructionAwareBeanPostProcessors, hasInstantiationAwareBeanPostProcessors, initBeanWrapper, isActuallyInCreation, isBeanNameInUse, isCacheBeanMetadata, isFactoryBean, isFactoryBean, isPrototype, isPrototypeCurrentlyInCreation, isSingleton, isTypeMatch, markBeanAsCreated, originalBeanName, registerCustomEditor, registerCustomEditors, registerDisposableBeanIfNecessary, registerScope, removeSingletonIfCreatedForTypeCheckOnly, requiresDestruction, resolveBeanClass, resolveEmbeddedValue, setBeanClassLoader, setBeanExpressionResolver, setCacheBeanMetadata, setConversionService, setParentBeanFactory, setSecurityContextProvider, setTempClassLoader, setTypeConverter, transformedBeanName`

    - ### Methods inherited from class org.springframework.beans.factory.support.FactoryBeanRegistrySupport

      `getCachedObjectForFactoryBean, getFactoryBean, getObjectFromFactoryBean, getTypeForFactoryBean`

    - ### Methods inherited from class org.springframework.beans.factory.support.DefaultSingletonBeanRegistry

      `addSingleton, addSingletonFactory, afterSingletonCreation, beforeSingletonCreation, containsSingleton, destroyBean, destroySingletons, getDependenciesForBean, getDependentBeans, getSingleton, getSingleton, getSingleton, getSingletonCount, getSingletonMutex, getSingletonNames, hasDependentBean, isCurrentlyInCreation, isDependent, isSingletonCurrentlyInCreation, onSuppressedException, registerContainedBean, registerDependentBean, registerDisposableBean, setCurrentlyInCreation`

    - ### Methods inherited from class org.springframework.core.SimpleAliasRegistry

      `canonicalName, checkForAliasCircle, getAliases, isAlias, registerAlias, removeAlias, resolveAliases`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.springframework.beans.factory.config.ConfigurableListableBeanFactory

      `ignoreDependencyInterface, ignoreDependencyType`

    - ### Methods inherited from interface org.springframework.beans.factory.config.AutowireCapableBeanFactory

      `applyBeanPostProcessorsAfterInitialization, applyBeanPostProcessorsBeforeInitialization, applyBeanPropertyValues, autowire, autowireBean, autowireBeanProperties, configureBean, createBean, createBean, destroyBean, initializeBean, resolveDependency`

    - ### Methods inherited from interface org.springframework.beans.factory.config.ConfigurableBeanFactory

      `addBeanPostProcessor, addEmbeddedValueResolver, addPropertyEditorRegistrar, copyRegisteredEditorsTo, destroyBean, destroyScopedBean, destroySingletons, getAccessControlContext, getBeanClassLoader, getBeanExpressionResolver, getBeanPostProcessorCount, getConversionService, getDependenciesForBean, getDependentBeans, getMergedBeanDefinition, getRegisteredScope, getRegisteredScopeNames, getTempClassLoader, getTypeConverter, isCacheBeanMetadata, isCurrentlyInCreation, isFactoryBean, registerAlias, registerCustomEditor, registerDependentBean, registerScope, resolveAliases, resolveEmbeddedValue, setBeanClassLoader, setBeanExpressionResolver, setCacheBeanMetadata, setConversionService, setCurrentlyInCreation, setParentBeanFactory, setTempClassLoader, setTypeConverter`

    - ### Methods inherited from interface org.springframework.beans.factory.HierarchicalBeanFactory

      `containsLocalBean, getParentBeanFactory`

    - ### Methods inherited from interface org.springframework.beans.factory.BeanFactory

      `containsBean, getAliases, getBean, getBean, getBean, getType, isPrototype, isSingleton, isTypeMatch`

    - ### Methods inherited from interface org.springframework.beans.factory.config.SingletonBeanRegistry

      `containsSingleton, getSingleton, getSingletonCount, getSingletonNames`

    - ### Methods inherited from interface org.springframework.beans.factory.support.BeanDefinitionRegistry

      `isBeanNameInUse`

    - ### Methods inherited from interface org.springframework.core.AliasRegistry

      `getAliases, isAlias, registerAlias, removeAlias`

- - ### Constructor Detail

    - #### DefaultListableBeanFactory

          public DefaultListableBeanFactory()

      Create a new DefaultListableBeanFactory.

    - #### DefaultListableBeanFactory

          public DefaultListableBeanFactory(BeanFactory parentBeanFactory)

      Create a new DefaultListableBeanFactory with the given parent.
      Parameters:
        `parentBeanFactory` - the parent BeanFactory

  - ### Method Detail

    - #### setSerializationId

          public void setSerializationId(String serializationId)

      Specify an id for serialization purposes, allowing this BeanFactory to be deserialized from this id back into the BeanFactory object, if needed.

    - #### setAllowBeanDefinitionOverriding

          public void setAllowBeanDefinitionOverriding(boolean allowBeanDefinitionOverriding)

      Set whether it should be allowed to override bean definitions by registering a different definition with the same name, automatically replacing the former. If not, an exception will be thrown. This also applies to overriding aliases.

      Default is "true".

      See Also:
        `registerBeanDefinition(java.lang.String, org.springframework.beans.factory.config.BeanDefinition)`

    - #### setAllowEagerClassLoading

          public void setAllowEagerClassLoading(boolean allowEagerClassLoading)

      Set whether the factory is allowed to eagerly load bean classes even for bean definitions that are marked as "lazy-init".

      Default is "true". Turn this flag off to suppress class loading for lazy-init beans unless such a bean is explicitly requested. In particular, by-type lookups will then simply ignore bean definitions without resolved class name, instead of loading the bean classes on demand just to perform a type check.

      See Also:
        `AbstractBeanDefinition.setLazyInit(boolean)`

    - #### setDependencyComparator

          public void setDependencyComparator(Comparator<Object> dependencyComparator)

      Set a `Comparator` for dependency Lists and arrays.
      See Also:
        `OrderComparator`, `AnnotationAwareOrderComparator`

    - #### getDependencyComparator

          public Comparator<Object> getDependencyComparator()

      Return the dependency comparator for this BeanFactory (may be `null`.

    - #### setAutowireCandidateResolver

          public void setAutowireCandidateResolver(AutowireCandidateResolver autowireCandidateResolver)

      Set a custom autowire candidate resolver for this BeanFactory to use when deciding whether a bean definition should be considered as a candidate for autowiring.

    - #### getAutowireCandidateResolver

          public AutowireCandidateResolver getAutowireCandidateResolver()

      Return the autowire candidate resolver for this BeanFactory (never `null`).

    - #### copyConfigurationFrom

          public void copyConfigurationFrom(ConfigurableBeanFactory otherFactory)

      Description copied from interface: `ConfigurableBeanFactory`
      Copy all relevant configuration from the given other factory.

      Should include all standard configuration settings as well as BeanPostProcessors, Scopes, and factory-specific internal settings. Should not include any metadata of actual bean definitions, such as BeanDefinition objects and bean name aliases.

      Specified by:
        `copyConfigurationFrom` in interface `ConfigurableBeanFactory`
      Overrides:
        `copyConfigurationFrom` in class `AbstractAutowireCapableBeanFactory`
      Parameters:
        `otherFactory` - the other BeanFactory to copy from

    - #### getBean

          public <T> T getBean(Class<T> requiredType)
                        throws BeansException

      Description copied from interface: `BeanFactory`
      Return the bean instance that uniquely matches the given object type, if any.
      Specified by:
        `getBean` in interface `BeanFactory`
      Parameters:
        `requiredType` - type the bean must match; can be an interface or superclass. `null` is disallowed.

        This method goes into `ListableBeanFactory` by-type lookup territory but may also be translated into a conventional by-name lookup based on the name of the given type. For more extensive retrieval operations across sets of beans, use `ListableBeanFactory` and/or `BeanFactoryUtils`.

      Returns:
        an instance of the single bean matching the required type
      Throws:
        `NoSuchBeanDefinitionException` - if no bean of the given type was found
        `NoUniqueBeanDefinitionException` - if more than one bean of the given type was found
        `BeansException`
      See Also:
        `ListableBeanFactory`

    - #### containsBeanDefinition

          public boolean containsBeanDefinition(String beanName)

      Description copied from class: `AbstractBeanFactory`
      Check if this bean factory contains a bean definition with the given name. Does not consider any hierarchy this factory may participate in. Invoked by `containsBean` when no cached singleton instance is found.

      Depending on the nature of the concrete bean factory implementation, this operation might be expensive (for example, because of directory lookups in external registries). However, for listable bean factories, this usually just amounts to a local hash lookup: The operation is therefore part of the public interface there. The same implementation can serve for both this template method and the public interface method in that case.

      Specified by:
        `containsBeanDefinition` in interface `ListableBeanFactory`
      Specified by:
        `containsBeanDefinition` in interface `BeanDefinitionRegistry`
      Specified by:
        `containsBeanDefinition` in class `AbstractBeanFactory`
      Parameters:
        `beanName` - the name of the bean to look for
      Returns:
        if this bean factory contains a bean definition with the given name
      See Also:
        `AbstractBeanFactory.containsBean(java.lang.String)`, `ListableBeanFactory.containsBeanDefinition(java.lang.String)`

    - #### getBeanDefinitionCount

          public int getBeanDefinitionCount()

      Description copied from interface: `ListableBeanFactory`
      Return the number of beans defined in the factory.

      Does not consider any hierarchy this factory may participate in, and ignores any singleton beans that have been registered by other means than bean definitions.

      Specified by:
        `getBeanDefinitionCount` in interface `ListableBeanFactory`
      Specified by:
        `getBeanDefinitionCount` in interface `BeanDefinitionRegistry`
      Returns:
        the number of beans defined in the factory

    - #### getBeanDefinitionNames

          public String[] getBeanDefinitionNames()

      Description copied from interface: `ListableBeanFactory`
      Return the names of all beans defined in this factory.

      Does not consider any hierarchy this factory may participate in, and ignores any singleton beans that have been registered by other means than bean definitions.

      Specified by:
        `getBeanDefinitionNames` in interface `ListableBeanFactory`
      Specified by:
        `getBeanDefinitionNames` in interface `BeanDefinitionRegistry`
      Returns:
        the names of all beans defined in this factory, or an empty array if none defined

    - #### getBeanNamesForType

          public String[] getBeanNamesForType(Class<?> type)

      Description copied from interface: `ListableBeanFactory`
      Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

      NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

      Does consider objects created by FactoryBeans, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type.

      Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beanNamesForTypeIncludingAncestors` to include beans in ancestor factories too.

      Note: Does not ignore singleton beans that have been registered by other means than bean definitions.

      This version of `getBeanNamesForType` matches all kinds of beans, be it singletons, prototypes, or FactoryBeans. In most implementations, the result will be the same as for `getBeanNamesOfType(type, true, true)`.

      Bean names returned by this method should always return bean names in the order of definition in the backend configuration, as far as possible.

      Specified by:
        `getBeanNamesForType` in interface `ListableBeanFactory`
      Parameters:
        `type` - the class or interface to match, or `null` for all bean names
      Returns:
        the names of beans (or objects created by FactoryBeans) matching the given object type (including subclasses), or an empty array if none
      See Also:
        `FactoryBean.getObjectType()`, `BeanFactoryUtils.beanNamesForTypeIncludingAncestors(ListableBeanFactory, Class)`

    - #### getBeanNamesForType

          public String[] getBeanNamesForType(Class<?> type,
                                              boolean includeNonSingletons,
                                              boolean allowEagerInit)

      Description copied from interface: `ListableBeanFactory`
      Return the names of beans matching the given type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

      NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

      Does consider objects created by FactoryBeans if the "allowEagerInit" flag is set, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type. If "allowEagerInit" is not set, only raw FactoryBeans will be checked (which doesn't require initialization of each FactoryBean).

      Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beanNamesForTypeIncludingAncestors` to include beans in ancestor factories too.

      Note: Does not ignore singleton beans that have been registered by other means than bean definitions.

      Bean names returned by this method should always return bean names in the order of definition in the backend configuration, as far as possible.

      Specified by:
        `getBeanNamesForType` in interface `ListableBeanFactory`
      Parameters:
        `type` - the class or interface to match, or `null` for all bean names
        `includeNonSingletons` - whether to include prototype or scoped beans too or just singletons (also applies to FactoryBeans)
        `allowEagerInit` - whether to initialize lazy-init singletons and objects created by FactoryBeans (or by factory methods with a "factory-bean" reference) for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references.
      Returns:
        the names of beans (or objects created by FactoryBeans) matching the given object type (including subclasses), or an empty array if none
      See Also:
        `FactoryBean.getObjectType()`, `BeanFactoryUtils.beanNamesForTypeIncludingAncestors(ListableBeanFactory, Class, boolean, boolean)`

    - #### getBeansOfType

          public <T> Map<String,T> getBeansOfType(Class<T> type)
                                           throws BeansException

      Description copied from interface: `ListableBeanFactory`
      Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

      NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

      Does consider objects created by FactoryBeans, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type.

      Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beansOfTypeIncludingAncestors` to include beans in ancestor factories too.

      Note: Does not ignore singleton beans that have been registered by other means than bean definitions.

      This version of getBeansOfType matches all kinds of beans, be it singletons, prototypes, or FactoryBeans. In most implementations, the result will be the same as for `getBeansOfType(type, true, true)`.

      The Map returned by this method should always return bean names and corresponding bean instances in the order of definition in the backend configuration, as far as possible.

      Specified by:
        `getBeansOfType` in interface `ListableBeanFactory`
      Parameters:
        `type` - the class or interface to match, or `null` for all concrete beans
      Returns:
        a Map with the matching beans, containing the bean names as keys and the corresponding bean instances as values
      Throws:
        `BeansException` - if a bean could not be created
      See Also:
        `FactoryBean.getObjectType()`, `BeanFactoryUtils.beansOfTypeIncludingAncestors(ListableBeanFactory, Class)`

    - #### getBeansOfType

          public <T> Map<String,T> getBeansOfType(Class<T> type,
                                                  boolean includeNonSingletons,
                                                  boolean allowEagerInit)
                                           throws BeansException

      Description copied from interface: `ListableBeanFactory`
      Return the bean instances that match the given object type (including subclasses), judging from either bean definitions or the value of `getObjectType` in the case of FactoryBeans.

      NOTE: This method introspects top-level beans only. It does not check nested beans which might match the specified type as well.

      Does consider objects created by FactoryBeans if the "allowEagerInit" flag is set, which means that FactoryBeans will get initialized. If the object created by the FactoryBean doesn't match, the raw FactoryBean itself will be matched against the type. If "allowEagerInit" is not set, only raw FactoryBeans will be checked (which doesn't require initialization of each FactoryBean).

      Does not consider any hierarchy this factory may participate in. Use BeanFactoryUtils' `beansOfTypeIncludingAncestors` to include beans in ancestor factories too.

      Note: Does not ignore singleton beans that have been registered by other means than bean definitions.

      The Map returned by this method should always return bean names and corresponding bean instances in the order of definition in the backend configuration, as far as possible.

      Specified by:
        `getBeansOfType` in interface `ListableBeanFactory`
      Parameters:
        `type` - the class or interface to match, or `null` for all concrete beans
        `includeNonSingletons` - whether to include prototype or scoped beans too or just singletons (also applies to FactoryBeans)
        `allowEagerInit` - whether to initialize lazy-init singletons and objects created by FactoryBeans (or by factory methods with a "factory-bean" reference) for the type check. Note that FactoryBeans need to be eagerly initialized to determine their type: So be aware that passing in "true" for this flag will initialize FactoryBeans and "factory-bean" references.
      Returns:
        a Map with the matching beans, containing the bean names as keys and the corresponding bean instances as values
      Throws:
        `BeansException` - if a bean could not be created
      See Also:
        `FactoryBean.getObjectType()`, `BeanFactoryUtils.beansOfTypeIncludingAncestors(ListableBeanFactory, Class, boolean, boolean)`

    - #### getBeanNamesForAnnotation

          public String[] getBeanNamesForAnnotation(Class<? extends Annotation> annotationType)

      Description copied from interface: `ListableBeanFactory`
      Find all names of beans whose `Class` has the supplied `Annotation` type, without creating any bean instances yet.
      Specified by:
        `getBeanNamesForAnnotation` in interface `ListableBeanFactory`
      Parameters:
        `annotationType` - the type of annotation to look for
      Returns:
        the names of all matching beans

    - #### getBeansWithAnnotation

          public Map<String,Object> getBeansWithAnnotation(Class<? extends Annotation> annotationType)

      Description copied from interface: `ListableBeanFactory`
      Find all beans whose `Class` has the supplied `Annotation` type, returning a Map of bean names with corresponding bean instances.
      Specified by:
        `getBeansWithAnnotation` in interface `ListableBeanFactory`
      Parameters:
        `annotationType` - the type of annotation to look for
      Returns:
        a Map with the matching beans, containing the bean names as keys and the corresponding bean instances as values

    - #### findAnnotationOnBean

          public <A extends Annotation> A findAnnotationOnBean(String beanName,
                                                               Class<A> annotationType)
                                                        throws NoSuchBeanDefinitionException

      Find a `Annotation` of `annotationType` on the specified bean, traversing its interfaces and super classes if no annotation can be found on the given class itself, as well as checking its raw bean class if not found on the exposed bean reference (e.g. in case of a proxy).
      Specified by:
        `findAnnotationOnBean` in interface `ListableBeanFactory`
      Parameters:
        `beanName` - the name of the bean to look for annotations on
        `annotationType` - the annotation class to look for
      Returns:
        the annotation of the given type if found, or `null`
      Throws:
        `NoSuchBeanDefinitionException` - if there is no bean with the given name

    - #### registerResolvableDependency

          public void registerResolvableDependency(Class<?> dependencyType,
                                                   Object autowiredValue)

      Description copied from interface: `ConfigurableListableBeanFactory`
      Register a special dependency type with corresponding autowired value.

      This is intended for factory/context references that are supposed to be autowirable but are not defined as beans in the factory: e.g. a dependency of type ApplicationContext resolved to the ApplicationContext instance that the bean is living in.

      Note: There are no such default types registered in a plain BeanFactory, not even for the BeanFactory interface itself.

      Specified by:
        `registerResolvableDependency` in interface `ConfigurableListableBeanFactory`
      Parameters:
        `dependencyType` - the dependency type to register. This will typically be a base interface such as BeanFactory, with extensions of it resolved as well if declared as an autowiring dependency (e.g. ListableBeanFactory), as long as the given value actually implements the extended interface.
        `autowiredValue` - the corresponding autowired value. This may also be an implementation of the `ObjectFactory` interface, which allows for lazy resolution of the actual target value.

    - #### isAutowireCandidate

          public boolean isAutowireCandidate(String beanName,
                                             DependencyDescriptor descriptor)
                                      throws NoSuchBeanDefinitionException

      Description copied from interface: `ConfigurableListableBeanFactory`
      Determine whether the specified bean qualifies as an autowire candidate, to be injected into other beans which declare a dependency of matching type.

      This method checks ancestor factories as well.

      Specified by:
        `isAutowireCandidate` in interface `ConfigurableListableBeanFactory`
      Parameters:
        `beanName` - the name of the bean to check
        `descriptor` - the descriptor of the dependency to resolve
      Returns:
        whether the bean should be considered as autowire candidate
      Throws:
        `NoSuchBeanDefinitionException` - if there is no bean with the given name

    - #### isAutowireCandidate

          protected boolean isAutowireCandidate(String beanName,
                                                DependencyDescriptor descriptor,
                                                AutowireCandidateResolver resolver)
                                         throws NoSuchBeanDefinitionException

      Determine whether the specified bean definition qualifies as an autowire candidate, to be injected into other beans which declare a dependency of matching type.
      Parameters:
        `beanName` - the name of the bean definition to check
        `descriptor` - the descriptor of the dependency to resolve
        `resolver` - the AutowireCandidateResolver to use for the actual resolution algorithm
      Returns:
        whether the bean should be considered as autowire candidate
      Throws:
        `NoSuchBeanDefinitionException`

    - #### isAutowireCandidate

          protected boolean isAutowireCandidate(String beanName,
                                                RootBeanDefinition mbd,
                                                DependencyDescriptor descriptor,
                                                AutowireCandidateResolver resolver)

      Determine whether the specified bean definition qualifies as an autowire candidate, to be injected into other beans which declare a dependency of matching type.
      Parameters:
        `beanName` - the name of the bean definition to check
        `mbd` - the merged bean definition to check
        `descriptor` - the descriptor of the dependency to resolve
        `resolver` - the AutowireCandidateResolver to use for the actual resolution algorithm
      Returns:
        whether the bean should be considered as autowire candidate

    - #### getBeanDefinition

          public BeanDefinition getBeanDefinition(String beanName)
                                           throws NoSuchBeanDefinitionException

      Description copied from class: `AbstractBeanFactory`
      Return the bean definition for the given bean name. Subclasses should normally implement caching, as this method is invoked by this class every time bean definition metadata is needed.

      Depending on the nature of the concrete bean factory implementation, this operation might be expensive (for example, because of directory lookups in external registries). However, for listable bean factories, this usually just amounts to a local hash lookup: The operation is therefore part of the public interface there. The same implementation can serve for both this template method and the public interface method in that case.

      Specified by:
        `getBeanDefinition` in interface `ConfigurableListableBeanFactory`
      Specified by:
        `getBeanDefinition` in interface `BeanDefinitionRegistry`
      Specified by:
        `getBeanDefinition` in class `AbstractBeanFactory`
      Parameters:
        `beanName` - the name of the bean to find a definition for
      Returns:
        the BeanDefinition for this prototype name (never `null`)
      Throws:
        `NoSuchBeanDefinitionException` - if there is no bean with the given name defined in this factory
      See Also:
        `RootBeanDefinition`, `ChildBeanDefinition`, `ConfigurableListableBeanFactory.getBeanDefinition(java.lang.String)`

    - #### freezeConfiguration

          public void freezeConfiguration()

      Description copied from interface: `ConfigurableListableBeanFactory`
      Freeze all bean definitions, signalling that the registered bean definitions will not be modified or post-processed any further.

      This allows the factory to aggressively cache bean definition metadata.

      Specified by:
        `freezeConfiguration` in interface `ConfigurableListableBeanFactory`

    - #### isConfigurationFrozen

          public boolean isConfigurationFrozen()

      Description copied from interface: `ConfigurableListableBeanFactory`
      Return whether this factory's bean definitions are frozen, i.e. are not supposed to be modified or post-processed any further.
      Specified by:
        `isConfigurationFrozen` in interface `ConfigurableListableBeanFactory`
      Returns:
        `true` if the factory's configuration is considered frozen

    - #### isBeanEligibleForMetadataCaching

          protected boolean isBeanEligibleForMetadataCaching(String beanName)

      Considers all beans as eligible for metadata caching if the factory's configuration has been marked as frozen.
      Overrides:
        `isBeanEligibleForMetadataCaching` in class `AbstractBeanFactory`
      Parameters:
        `beanName` - the name of the bean
      Returns:
        `true` if the bean's metadata may be cached at this point already
      See Also:
        `freezeConfiguration()`

    - #### preInstantiateSingletons

          public void preInstantiateSingletons()
                                        throws BeansException

      Description copied from interface: `ConfigurableListableBeanFactory`
      Ensure that all non-lazy-init singletons are instantiated, also considering `FactoryBeans`. Typically invoked at the end of factory setup, if desired.
      Specified by:
        `preInstantiateSingletons` in interface `ConfigurableListableBeanFactory`
      Throws:
        `BeansException` - if one of the singleton beans could not be created. Note: This may have left the factory with some beans already initialized! Call `ConfigurableBeanFactory.destroySingletons()` for full cleanup in this case.
      See Also:
        `ConfigurableBeanFactory.destroySingletons()`

    - #### registerBeanDefinition

          public void registerBeanDefinition(String beanName,
                                             BeanDefinition beanDefinition)
                                      throws BeanDefinitionStoreException

      Description copied from interface: `BeanDefinitionRegistry`
      Register a new bean definition with this registry. Must support RootBeanDefinition and ChildBeanDefinition.
      Specified by:
        `registerBeanDefinition` in interface `BeanDefinitionRegistry`
      Parameters:
        `beanName` - the name of the bean instance to register
        `beanDefinition` - definition of the bean instance to register
      Throws:
        `BeanDefinitionStoreException` - if the BeanDefinition is invalid or if there is already a BeanDefinition for the specified bean name (and we are not allowed to override it)
      See Also:
        `RootBeanDefinition`, `ChildBeanDefinition`

    - #### removeBeanDefinition

          public void removeBeanDefinition(String beanName)
                                    throws NoSuchBeanDefinitionException

      Description copied from interface: `BeanDefinitionRegistry`
      Remove the BeanDefinition for the given name.
      Specified by:
        `removeBeanDefinition` in interface `BeanDefinitionRegistry`
      Parameters:
        `beanName` - the name of the bean instance to register
      Throws:
        `NoSuchBeanDefinitionException` - if there is no such bean definition

    - #### resetBeanDefinition

          protected void resetBeanDefinition(String beanName)

      Reset all bean definition caches for the given bean, including the caches of beans that are derived from it.
      Parameters:
        `beanName` - the name of the bean to reset

    - #### allowAliasOverriding

          protected boolean allowAliasOverriding()

      Only allows alias overriding if bean definition overriding is allowed.
      Overrides:
        `allowAliasOverriding` in class `SimpleAliasRegistry`

    - #### registerSingleton

          public void registerSingleton(String beanName,
                                        Object singletonObject)
                                 throws IllegalStateException

      Description copied from interface: `SingletonBeanRegistry`
      Register the given existing object as singleton in the bean registry, under the given bean name.

      The given instance is supposed to be fully initialized; the registry will not perform any initialization callbacks (in particular, it won't call InitializingBean's `afterPropertiesSet` method). The given instance will not receive any destruction callbacks (like DisposableBean's `destroy` method) either.

      When running within a full BeanFactory: Register a bean definition instead of an existing instance if your bean is supposed to receive initialization and/or destruction callbacks.

      Typically invoked during registry configuration, but can also be used for runtime registration of singletons. As a consequence, a registry implementation should synchronize singleton access; it will have to do this anyway if it supports a BeanFactory's lazy initialization of singletons.

      Specified by:
        `registerSingleton` in interface `SingletonBeanRegistry`
      Overrides:
        `registerSingleton` in class `DefaultSingletonBeanRegistry`
      Parameters:
        `beanName` - the name of the bean
        `singletonObject` - the existing singleton object
      Throws:
        `IllegalStateException`
      See Also:
        `InitializingBean.afterPropertiesSet()`, `DisposableBean.destroy()`, `BeanDefinitionRegistry.registerBeanDefinition(java.lang.String, org.springframework.beans.factory.config.BeanDefinition)`

    - #### destroySingleton

          public void destroySingleton(String beanName)

      Description copied from class: `DefaultSingletonBeanRegistry`
      Destroy the given bean. Delegates to `destroyBean` if a corresponding disposable bean instance is found.
      Overrides:
        `destroySingleton` in class `DefaultSingletonBeanRegistry`
      Parameters:
        `beanName` - the name of the bean
      See Also:
        `DefaultSingletonBeanRegistry.destroyBean(java.lang.String, org.springframework.beans.factory.DisposableBean)`

    - #### resolveDependency

          public Object resolveDependency(DependencyDescriptor descriptor,
                                          String beanName,
                                          Set<String> autowiredBeanNames,
                                          TypeConverter typeConverter)
                                   throws BeansException

      Description copied from interface: `AutowireCapableBeanFactory`
      Resolve the specified dependency against the beans defined in this factory.
      Specified by:
        `resolveDependency` in interface `AutowireCapableBeanFactory`
      Parameters:
        `descriptor` - the descriptor for the dependency
        `beanName` - the name of the bean which declares the present dependency
        `autowiredBeanNames` - a Set that all names of autowired beans (used for resolving the present dependency) are supposed to be added to
        `typeConverter` - the TypeConverter to use for populating arrays and collections
      Returns:
        the resolved object, or `null` if none found
      Throws:
        `BeansException` - in dependency resolution failed

    - #### doResolveDependency

          public Object doResolveDependency(DependencyDescriptor descriptor,
                                            String beanName,
                                            Set<String> autowiredBeanNames,
                                            TypeConverter typeConverter)
                                     throws BeansException

      Throws:
        `BeansException`

    - #### findAutowireCandidates

          protected Map<String,Object> findAutowireCandidates(String beanName,
                                                              Class<?> requiredType,
                                                              DependencyDescriptor descriptor)

      Find bean instances that match the required type. Called during autowiring for the specified bean.
      Parameters:
        `beanName` - the name of the bean that is about to be wired
        `requiredType` - the actual type of bean to look for (may be an array component type or collection element type)
        `descriptor` - the descriptor of the dependency to resolve
      Returns:
        a Map of candidate names and candidate instances that match the required type (never `null`)
      Throws:
        `BeansException` - in case of errors
      See Also:
        `AbstractAutowireCapableBeanFactory.autowireByType(java.lang.String, org.springframework.beans.factory.support.AbstractBeanDefinition, org.springframework.beans.BeanWrapper, org.springframework.beans.MutablePropertyValues)`, `AbstractAutowireCapableBeanFactory.autowireConstructor(java.lang.String, org.springframework.beans.factory.support.RootBeanDefinition, java.lang.reflect.Constructor<?>[], java.lang.Object[])`

    - #### determinePrimaryCandidate

          protected String determinePrimaryCandidate(Map<String,Object> candidateBeans,
                                                     DependencyDescriptor descriptor)

      Determine the primary autowire candidate in the given set of beans.
      Parameters:
        `candidateBeans` - a Map of candidate names and candidate instances that match the required type, as returned by `findAutowireCandidates(java.lang.String, java.lang.Class<?>, org.springframework.beans.factory.config.DependencyDescriptor)`
        `descriptor` - the target dependency to match against
      Returns:
        the name of the primary candidate, or `null` if none found

    - #### isPrimary

          protected boolean isPrimary(String beanName,
                                      Object beanInstance)

      Return whether the bean definition for the given bean name has been marked as a primary bean.
      Parameters:
        `beanName` - the name of the bean
        `beanInstance` - the corresponding bean instance
      Returns:
        whether the given bean qualifies as primary

    - #### matchesBeanName

          protected boolean matchesBeanName(String beanName,
                                            String candidateName)

      Determine whether the given candidate name matches the bean name or the aliases stored in this bean definition.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### writeReplace

          protected Object writeReplace()
                                 throws ObjectStreamException

      Throws:
        `ObjectStreamException`